<?php

add_action("admin_init", 'add_common_fields_init');
function add_common_fields_init()
{
  register_field_type('text', 'Text', 'textfield-linked');
  register_field_type('textarea', 'Textarea', 'textarea-linked');
  register_field_type('select', 'Drop box', 'select-linked');
  register_field_type('radio', 'Radio group', 'radio-linked');
  register_field_type('check', 'Check box', 'check-linked');
  
  // textfield
  add_action(BUILD_SHOW . 'text', 'show_textfield', 1, 3);
  add_action(BUILD_SAVE . 'text', 'save_textfield', 1, 2);
  
  // textarea
  add_action(BUILD_SHOW . 'textarea', 'show_textarea', 1, 3);
  add_action(BUILD_SAVE . 'textarea', 'save_textarea', 1, 2);
  
  // select
  add_action(BUILD_SHOW . 'select', 'show_select', 1, 3);
  add_action(BUILD_SAVE . 'select', 'save_select', 1, 2);
  
  // radio
  add_action(BUILD_SHOW . 'radio', 'show_radio', 1, 3);
  add_action(BUILD_SAVE . 'radio', 'save_radio', 1, 2);
  
  // check
  add_action(BUILD_SHOW . 'check', 'show_check', 1, 3);
  add_action(BUILD_SAVE . 'check', 'save_check', 1, 2);
}

add_action('admin_menu', 'add_common_fields_options');
function add_common_fields_options()
{
  // textarea
  add_filter(FIELD_SHOW, 'show_textarea_options', 1, 2);
  add_filter(FIELD_SAVE, 'save_textarea_options', 1, 2);
  
  // textarea
  add_filter(FIELD_SHOW, 'show_select_options', 1, 2);
  add_filter(FIELD_SAVE, 'save_select_options', 1, 2);
  
  // textarea
  add_filter(FIELD_SHOW, 'show_radio_options', 1, 2);
  add_filter(FIELD_SAVE, 'save_radio_options', 1, 2);
  
  // textarea
  add_filter(FIELD_SHOW, 'show_check_options', 1, 2);
  add_filter(FIELD_SAVE, 'save_check_options', 1, 2);
}

include_once('fields-builder-textfield.php');
include_once('fields-builder-textarea.php');
include_once('fields-builder-select.php');
include_once('fields-builder-radio.php');
include_once('fields-builder-check.php');

?>