<?php
/*
Plugin Name: Fields
Version: 0.1
Author URI: http://calce.net/
Plugin URI: http://calce.net/fields
Description:  Creates custom write panels to manage post custom fields.
Author: Khanh Cao

	USAGE:

	See http://calce.net/fields

	LICENCE:

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    
*/

include('fields-def.php');
include('fields-utils.php');
include('fields-base.php');
include('fields-boxes.php');
include('fields-groups.php');
include('fields-options.php');
include('fields-box-builder.php');
include('fields-field-builders.php');

class fields
{
  function fields()
  { 
    // Destroy all data 
    /* $groups = array(); update_option(OPTION_GROUPS, $groups);
    $boxes = array(); update_option(OPTION_BOXES, $boxes); */
    global $page_name, $page_url;
    $siteurl = get_settings('siteurl');
    $page_name = dirname(plugin_basename(__FILE__));
    $page_url = $siteurl . '/wp-admin/options-general.php?page=' . $page_name;
    add_action("admin_menu", array($this, "init_menu"));
    add_action("admin_init", array($this, 'admin_init'));
  }
  
  /**/
  function admin_init()
  {
    global $fields_boxes, $fields_groups;
    $fields_boxes =  new fields_boxes();
    $fields_groups = new fields_groups();
    
    $boxes = $fields_boxes->load();
    $groups = $fields_groups->load();
    
    $box_builder = new fields_box_builder();
    $box_builder->build($boxes, $groups);
    
    add_action('save_post', array($box_builder, 'save'), 11, 2);    
    add_action('save_page', array($box_builder, 'save'), 11, 2);    

    //add_meta_box('debug', 'Debug', array($this, 'show_debug_pane'), 'program', 'advanced', 'high');
    
    $req_uri = $_SERVER['REQUEST_URI'];
    if (strstr($req_uri, 'page=' . $page_name))
    {
      wp_enqueue_script('fields',
        WP_PLUGIN_URL . '/fields/js/fields.js',
        array(), '1.0', true );

      wp_enqueue_style('fields',
        WP_PLUGIN_URL . '/fields/fields.css',
        array(), '1.0');
    }
    
    if (strstr($req_uri, 'wp-admin/post-new.php') || strstr($req_uri, 'wp-admin/post.php') || strstr($req_uri, 'wp-admin/edit.php')) 
    {
      wp_enqueue_script('fields',
        WP_PLUGIN_URL . '/fields/js/boxes.js',
        array(), '1.0', true );
        
      wp_enqueue_style('fields-boxes',
        WP_PLUGIN_URL . '/fields/boxes.css',
        array(), '1.0');

      wp_enqueue_script('cookie',
        WP_PLUGIN_URL . '/fields/js/jquery.cookie.js',
        array(), '1.0', true );
    }
  }

  /**/
  function init_menu() {     
    add_options_page('Fields', 'Fields', 10, 'fields', array($this, 'manage'));    
  }
    
  /* Option pages */
  function manage()
  {
    global $tab, $action, $item, $sub_item, $form_method, $page_url, $crumbs, $update, $error;
    $tab = $_REQUEST['tab'];
    $action = $_REQUEST['action'];
    $item = $_REQUEST['item'];
    $sub_item = $_REQUEST['sub-item'];
    $crumbs = array();
    $update = array();
    $error = array();
    
    global $fields_boxes, $fields_groups;    
    
    if ($tab == TAB_GROUPS)
    {
      $page = $fields_groups;
    }
    elseif ($tab == TAB_OPTIONS)
    {
      $page = new fields_options();
    }
    else
    {
      $tab = TAB_BOXES;
      $page = $fields_boxes;
    }
    $page->think();
    
    $title = apply_filters('fields_page_title', 'Fields');
    $url = $page_url . '&tab=';
    ?>    
    
    <div class="wrap nosubsub">
      <h2><?php echo $title; ?></h2>
      <ul class="subsubsub">
        <li>
          <a <?php if ($tab == 'boxes') echo 'class="current"'; ?> href="<?php echo $url; ?>boxes">Boxes</a> |
        </li>
        <li>
          <a <?php if ($tab == 'groups') echo 'class="current"'; ?> href="<?php echo $url; ?>groups">Groups</a> |
        </li>
        <li>
          <a <?php if ($tab == 'options') echo 'class="current"'; ?> href="<?php echo $url; ?>options">Options</a>
        </li>
      </ul>
      <?php //$this->show_debug_pane(); ?>
            
      <?php
      // notice
      if (sizeof($update) > 0)
      {
        foreach ($update as $msg)
          echo "<div class='updated'><p>$msg</p></div>\n";
      }
      if (sizeof($error) > 0)
      {
        foreach ($error as $msg)
          echo "<div class='error'><p>$msg</p></div>\n";
      }
      ?>
      
      <?php $page->show(); ?>
    </div>
    
    <?php        
  }
  
  function show_debug_pane()
  {
    global $form_method, $debug_lines;
  ?>
    <table class="form-table">
      <tr><td>
      <div><?php echo $form_method; ?></div>
      <div><?php print_r($_REQUEST); ?></div>
      </td>
      </tr>
      <tr>
        <td>
        <?php
          foreach ($debug_lines as $line)
          {
            echo "<div>$line</div>";
          }
        ?>
        </td>
      </tr>
    </table>
  <?php
  }    
}

global $debug_lines;
$debug_lines = array();

global $calce_field_types;
$calce_field_types = array();

global $fields;
$fields = new fields();

global $form_method;
$form_method = $_SERVER['REQUEST_METHOD'];

?>